#!/usr/local/bin/python3
import numpy as np
import matplotlib.pyplot as plt
import math as m
import os
import flux_map as fm

homeDir = os.environ['HOME']
#relDir = "/SCRATCH/KSTAR_runs/22022302_n1_rmp/100/"
fileName = "nimfl0240408.dat"
fileName = "nimfl0263849.dat"
#fileName = "nimfl0000000.dat"
path = "/Volumes/Auburn/ResearchStorage/KSTAR_runs/22032401_n1_rmp/240408/"
path = "/Volumes/Auburn/ResearchStorage/KSTAR_runs/22031401_n1_rmp_dt2/fl_263849/"
#path = "/Volumes/Auburn/ResearchStorage/KSTAR_runs/22031401_n1_rmp_dt2/fl_00000/"
path = "/Volumes/Auburn/ResearchStorage/174446_mu_shape_analysis/21061101/nimfl_dirs/66000/"
path = "/Volumes/Auburn/ResearchStorage/174446_mu_shape_analysis/22040601/100000/"
path = "/Volumes/Auburn/ResearchStorage/KSTAR_runs/19118_2800_nl/23032902/nimfl_rundir/176000/"
fileName =  "nimfl0176000.dat"
fullFile = path + fileName

dumpfile = path + 'dumpgll.240408.h5'
dumpfile = path + 'dumpgll.263849.h5'
dumpfile = path + 'dumpgll.66000.h5'
dumpfile = path + 'dumpgll.176000.h5'

#dumpfile = path + 'dumpgll.00000.h5'
rz, psi, theta, q = fm.comp_pol_angle(dumpfile, 
                                      rzo=[1.768,-0.018831,0.0],
                                      nsurf=500,
                                      addpert=False,
                                      fargs={'plot':True})

map = fm.fluxMap(rz, psi, theta, debug=True)

RLIM = np.array([
  1.265, 1.608, 1.683, 1.631,
  1.578, 1.593, 1.626, 2.006,
  2.233, 2.235, 2.263, 2.298,
  2.316, 2.316, 2.298, 2.263,
  2.235, 2.233, 2.006, 1.626,
  1.593, 1.578, 1.631, 1.683,
  1.608, 1.265, 1.265
])
ZLIM = np.array([
  1.085, 1.429, 1.431, 1.326,
  1.32, 1.153, 1.09, 0.773,
  0.444, 0.369, 0.31, 0.189,
  6.2E-2, -6.2E-2, -0.189, -0.31,
  -0.369, -0.444, -0.773, -1.09,
  -1.153, -1.32, -1.326, -1.431,
  -1.429, -1.085, 1.085
])
LIMITER = (RLIM, ZLIM)

DRWALL = np.array([2.443303419949772, 2.445003360252620, 2.435206281190796, 
      2.397229070763543, 2.349096435450708, 2.296697511366329, 
      2.226202284287925, 2.132775562815938, 2.027583832063605, 
      1.910630360626907, 1.778445679008138, 1.635079922339590, 
      1.484330005656411, 1.324367385828326, 1.162101456042379, 
      1.027709774120046, 0.9531004737753517, 0.9291925921464999, 
      0.9306128757867301, 0.9373734199854492, 0.9374716427460326, 
      0.9309174125983126, 0.9309062023801610, 0.9330912388264760, 
      0.9290759363555934, 0.9313924528732267, 0.9325192643910063, 
      0.9298801313664510, 0.9355275529633224, 0.9383072037111380, 
      0.9315511559488159, 0.9286559025958544, 0.9465601634341064, 
      1.000382927938164, 1.092264926894742, 1.215568147385899, 
      1.343869169462016, 1.443290163237878, 1.545839461727406, 
      1.659387736523215, 1.785869422676203, 1.919004656822144, 
      2.048477467998743, 2.170484269722559, 2.273692536052303, 
      2.345258986779728, 2.405126351903085, 2.441499638224660, 
      2.444671091311594, 2.4415506197120, 2.443303419949772])

DZWALL = np.array([0.1070010083064705, 0.2407488482372501, 0.3804810616106032, 
      0.5159387361983736, 0.6503946165564584, 0.7935848357649634, 
      0.9352181481113857, 1.059155770383247, 1.178561334034986, 
      1.293970423413222, 1.384524187526246, 1.432284507191533, 
      1.453445898862813, 1.463657741995547, 1.445934022958783, 
      1.359242878727507, 1.195323634649968, 1.004001380805289, 
      0.8237611508094629, 0.6662857938612209, 0.5291230710159969, 
      0.4026518905384536, 0.2771781125246763, 0.1533390886307173, 
      2.974376768179259E-02, -9.479066317849494E-02, 
      -0.2219425844279092, -0.3553396294163588, 
      -0.4901821828518301, -0.6351465365923717, 
      -0.8027612626835731, -0.9874117999240944, 
      -1.170409819654592, -1.321107993701108, 
      -1.416381737427392, -1.457845801192058, 
      -1.463452619441855, -1.457140387484942, 
      -1.446593354617252, -1.427322714872727, 
      -1.380546621923976, -1.286917884397917, 
      -1.155789433396968, -1.012819480748024, 
      -0.8474364195572380, -0.6613050759653780, 
      -0.4935139420070444, -0.3285717485346793, 
    -0.1676609207868461,-2.517907021385858E-02,0.1070010083064715
])

DWALL = (DRWALL,DZWALL)

DZLIM = np.array([0.0, 0.9640, 
  0.9680, 1.0010, 1.0190, 
   1.0770, 1.070, 1.0960, 
   1.1130, 1.1380, 1.1470, 
   1.1650, 1.2170, 1.2170, 
   1.16240, 1.162380, 1.16260, 
   1.16450, 1.165940, 1.165910, 
   1.168960, 1.171750, 1.175560, 
   1.1830, 1.18350, 1.1850, 
   1.1880, 1.1910, 1.1960, 
   1.2020, 1.2080, 1.2140, 
   1.2210, 1.2310, 1.2380, 
   1.2440, 1.2540, 1.2780, 
   1.290, 1.3310, 1.3470, 
   1.3480, 1.3480, 1.3480, 
   1.3480, 1.3480, 1.3480, 
   1.310, 1.310, 1.292380, 
   1.282680, 1.256440, 1.229550, 
   1.195760, 1.194020, 1.164870, 
   1.164210, 1.156960, 1.15730, 
   1.161320, 1.1640, 1.24050, 
   1.234580, 1.234280, 1.231740, 
   1.21330, 1.210610, 1.204860, 
   1.202140, 1.196420, 1.185110, 
   1.16070, 1.124260, 1.122560, 
   1.121380, 1.116920, 1.114390, 
   1.112440, 1.094890, 1.08530, 
   1.079880, 1.0770, 1.0770, 
   1.040, 0.9930, 0.7090, 
  0.461430, 0.415830, 0.272180, 
  0.170180, 7.0120000000000002E-2, -3.1789999999999999E-2, 
 -0.144350, -0.214830, -0.326690, 
 -0.386770, -0.453040, -0.477570, 
 -0.9730, -1.1740, -1.2110, 
  -1.250, -1.250, -1.250, 
  -1.3290, -1.3290, -1.3630, 
  -1.3630, -1.3630, -1.2230, 
  -1.2230, -0.830, -0.80, 
 -0.4150, -0.40, -1.0000000000000000E-3,0.0])

DRLIM = np.array([1.0160, 1.0160,      
   1.0160, 1.0160, 1.0160,      
   1.0160, 1.0160, 1.0160,      
   1.0160, 1.0160, 1.0160,      
   1.0120, 1.0010, 1.0290,      
   1.0420, 1.0460, 1.0560,      
   1.0970, 1.1080, 1.1160,      
   1.1340, 1.1480, 1.1620,      
   1.1810, 1.1820, 1.1850,      
   1.190, 1.1950, 1.2010,     
   1.2090, 1.2150, 1.2220,      
   1.2280, 1.2340, 1.2390,      
   1.2420, 1.2480, 1.2580,      
   1.2630, 1.280, 1.280,      
   1.280, 1.310, 1.3280,      
   1.3610, 1.380, 1.4190,      
   1.4190, 1.3720, 1.371670,      
   1.370030, 1.366880, 1.367190,      
   1.371780, 1.372240, 1.386620,      
   1.387080, 1.403820, 1.411270,      
   1.418570, 1.4210, 1.486630,      
   1.49730, 1.497620, 1.497450,      
   1.492750, 1.49260, 1.492610,      
   1.492790, 1.49340, 1.49470,      
   1.496220, 1.479810, 1.480820,      
   1.481490, 1.486460, 1.490950,      
   1.503050, 1.596970, 1.62550,      
   1.637520, 1.6470, 1.7850,      
   2.070, 2.1280, 2.2450,      
   2.339560, 2.347080, 2.349130,      
   2.351030, 2.351580, 2.351250,      
   2.350510, 2.349650, 2.34870,      
   2.34760, 2.34020, 2.329420,      
   2.1340, 1.7860, 1.7680,      
   1.7680, 1.6820, 1.3720,      
   1.3720, 1.420, 1.420,      
   1.2730, 1.1530, 1.0160,      
   1.0160, 1.0160, 1.0160,      
   1.0160, 1.0160, 1.0160, 1.016])

DRLIMS = np.array([2.35, 2.35, 2.35, 2.35, 2.35, 
  2.35, 2.35, 2.35, 2.34666, 2.32531, 
  2.29755, 2.26978, 2.24201, 2.21424, 2.18647, 
  2.1587, 2.12578, 2.06763, 1.9938, 1.91744, 
  1.84108, 1.76472, 1.68819, 1.6055, 1.51398, 
  1.42152, 1.32266, 1.22983, 1.14811, 1.07087, 
  1.01982, 1.015, 1.015, 1.015, 1.015, 
  1.015, 1.015, 1.015, 1.015, 1.015, 
  1.015, 1.015, 1.015, 1.015, 1.015, 
  1.015, 1.015, 1.015, 1.015, 1.015, 
  1.015, 1.015, 1.015, 1.015, 1.015, 
  1.015, 1.015, 1.015, 1.015, 1.015, 
  1.01561, 1.04456, 1.11639, 1.20711, 1.31287, 
  1.4218, 1.51755, 1.60608, 1.69367, 1.77666, 
  1.84784, 1.91726, 1.98669, 2.05612, 2.12129, 
  2.15874, 2.18493, 2.21105, 2.23718, 2.2633, 
  2.28942, 2.31554, 2.34024, 2.34988, 2.35, 
  2.35, 2.35, 2.35, 2.35, 2.35, 
  2.35])

DZLIMS = np.array([0.01798, 0.05486, 0.10973, 0.16459, 0.21945, 
  0.27431, 0.32918, 0.38404, 0.44058, 0.50615, 
  0.57494, 0.64373, 0.71253, 0.78132, 0.85011, 
  0.91891, 0.98511, 1.03202, 1.04619, 1.05242, 
  1.05863, 1.06485, 1.07178, 1.10483, 1.17535, 
  1.24839, 1.30654, 1.29655, 1.24444, 1.18983, 
  1.12791, 1.05329, 0.97734, 0.90139, 0.82544, 
  0.7495, 0.67355, 0.5976, 0.52165, 0.44571, 
  0.36976, 0.29381, 0.21786, 0.14191, 0.06596, 
  -0.01052, -0.08785, -0.16526, -0.24266, -0.32007, 
  -0.39748, -0.47489, -0.55229, -0.6297, -0.70711, 
  -0.78452, -0.86192, -0.93933, -1.01674, -1.09415, 
  -1.17157, -1.24918, -1.32357, -1.35876, -1.3453, 
  -1.28381, -1.25344, -1.25, -1.24979, -1.21784, 
  -1.151, -1.10693, -1.06366, -1.0204, -0.9747, 
  -0.91322, -0.84533, -0.77739, -0.70945, -0.64151, 
  -0.57357, -0.50564, -0.43845, -0.3792, -0.32497, 
  -0.27081, -0.21665, -0.16249, -0.10832, -0.05416, 
  0.01798
])

nimbdry = [2.4427994658877048, -0.0138381561686206,
2.4424270178190857, -0.0004409553332683,
2.4418933056531418, 0.0249696019044662,
2.4417213473993429, 0.0504950047593250,
2.4418282858806619, 0.0640517320687931,
2.4420857372275568, 0.0777199875196597,
2.4429642088031476, 0.1039477003110055,
2.4441648752057348, 0.1306689365602059,
2.4448010870882553, 0.1449754994505607,
2.4453594415357363, 0.1594004785109515,
2.4460081214001774, 0.1871060409319140,
2.4459099929123878, 0.2152403254611984,
2.4455120356315816, 0.2302417396536814,
2.4448655174189606, 0.2452091173198991,
2.4429597188133627, 0.2738632702865331,
2.4401676062757116, 0.3028874797816497,
2.4383499730270173, 0.3183549364586934,
2.436341208025830, 0.3336004107173421,
2.4319281705309796, 0.3628098610819448,
2.4267347990711263, 0.3924513999183371,
2.4236868166206853, 0.4082763154728287,
2.4205456369788387, 0.4236310092877050,
2.4140503301270582, 0.4531078626323982,
2.4068202621493531, 0.4830880550165261,
2.4027103702687098, 0.4991235912782492,
2.3986123919306777, 0.5144673348325319,
2.3903096536795680, 0.5439584586017600,
2.3812710514732762, 0.5739963014450709,
2.3761922434993257, 0.5900698781691183,
2.3712301713696275, 0.6052878755998115,
2.3612541045767741, 0.6345228616534840,
2.3505025824308450, 0.6642825316368699,
2.3444959028938643, 0.6801882798315727,
2.3386615791546701, 0.6952024799523892,
2.3269879927219748, 0.7239926633008046,
2.3144751081358832, 0.7532105855887358,
2.3075182861430776, 0.7687900619945418,
2.3007721387875977, 0.7834565631233491,
2.2873443849600776, 0.8115099358619268,
2.2730362692255870, 0.8398606425570656,
2.2651182400839227, 0.8549250447422251,
2.2574637651241769, 0.8691057690272014,
2.2423064457496222, 0.8961515138697793,
2.2262772658896464, 0.9233971233669620,
2.2174627817238846, 0.9378491425994638,
2.2089453841655380, 0.9514801152982307,
2.1921757225290062, 0.9774432219233822,
2.1745679181044610, 1.0035530200743268,
2.1649347008865951, 1.0173835583713371,
2.1556572490733070, 1.0304126270373513,
2.1374710117082465, 1.0551904784060804,
2.1184777849393455, 1.0800446443996734,
2.1081235028173237, 1.0931709741872737,
2.0981676127262676, 1.1055281345686079,
2.0787114950550634, 1.1289426603854205,
2.0584728369974652, 1.1522987852362510,
2.0474731705297931, 1.1645724317270418,
2.0368985126764159, 1.1760960282109445,
2.0162914117584703, 1.1977929916627295,
1.9949363664843023, 1.2192227151634134,
1.9833657406658394, 1.2303882519102358,
1.9722298549571193, 1.2408408341201305,
1.9505969253352780, 1.2603218627504678,
1.9282794376256669, 1.2792828148915456,
1.9162325059688297, 1.2890417984170746,
1.9046177325287907, 1.2981335757028898,
1.8821428524742443, 1.3148449244930580,
1.8590848620407059, 1.3308007450598749,
1.8466940256150248, 1.3388863412012530,
1.8347554251702336, 1.3463519158800192,
1.8117606916645548, 1.3598689988684010,
1.7883146143351740, 1.3725082052443929,
1.7757750834800055, 1.3788079560976434,
1.7636394647398492, 1.3846150998554159,
1.7403670551688339, 1.3949846468504932,
1.7167684698505052, 1.4045133525761668,
1.7041972807185961, 1.4092144639021975,
1.6919417370489263, 1.4135572579566105,
1.6685155079740184, 1.4212382433500701,
1.6448501611932527, 1.4282400054807820,
1.6322752385695380, 1.4316735299695607,
1.6198862172172854, 1.4348743440358067,
1.5962481806227971, 1.4405093984648984,
1.5724184302494926, 1.4456050762416945,
1.5597727968807980, 1.4480897279512071,
1.5473289918102653, 1.4503930081284684,
1.5236128247480394, 1.4543987553549320,
1.4997343852623608, 1.4579541963313436,
1.4870768576225972, 1.4596408007752486,
1.4743867113023694, 1.4611979204759533,
1.4502237289512463, 1.4637965955546366,
1.4259381050877209, 1.4658897234515058,
1.4130814971616497, 1.4667885527582167,
1.4002331620209492, 1.4675303226182947,
1.3758203782615079, 1.4684867742386631,
1.3513572905208306, 1.4688128497061386,
1.3384437532593687, 1.4687106110127046,
1.3255632153898733, 1.4684095002940520,
1.3011816005755739, 1.4672238237941007,
1.2768821039946083, 1.4651911341316219,
1.2641185141177731, 1.4637415987032043,
1.2514925813106352, 1.4620341000809658,
1.2277341152335330, 1.4579886531168817,
1.2042623128840204, 1.4528263305515334,
1.1920301366192605, 1.4496039823399360,
1.1800900350570285, 1.4460861433031713,
1.1578158035959885, 1.4384232029880246,
1.1360933466305487, 1.4293822872432564,
1.1248946169428844, 1.4240189842521354,
1.1140959955226308, 1.4183414998417965,
1.0941857807514794, 1.4064613172759297,
1.0751188124190918, 1.3930125118112857,
1.0654206473690662, 1.3852969310835141,
1.0561075966238753, 1.3772134205510762,
1.0392226457014575, 1.3606989373671647,
1.0234227549285257, 1.3426070441547417,
1.0155445929460942, 1.3324435961145302,
1.0079558105767392, 1.3218094417392570,
0.9945242053069099, 1.3004811831178227,
0.9823393024758931, 1.2777483342852161,
0.9764409049341375, 1.2651922401925009,
0.9707620021713816, 1.2519568487257029,
0.9610224355308629, 1.2259344334830327,
0.9526282603656121, 1.1987905207845024,
0.9487269336767101, 1.1840811918846141,
0.9450255139562810, 1.1684535005735259,
0.9390283326224155, 1.1382365300897961,
0.9343035845066856, 1.1074054238063002,
0.9322888525310494, 1.0909669399340196,
0.9304803424018737, 1.0733933145018648,
0.9279378717286153, 1.0399536078231981,
0.9264231882028408, 1.0065483748727384,
0.9259865551630080, 0.9890117068030526,
0.9257619814635828, 0.9701897616256063,
0.9259447755672071, 0.9349282346743776,
0.9267670347958648, 0.9003748205850989,
0.9273979004574409, 0.8824872275283784,
0.9282053234573390, 0.8633029212695946,
0.9299645944532773, 0.8278597593868967,
0.9318764868678828, 0.7937021512553866,
0.9328910515818287, 0.7762237911279187,
0.9339756472687799, 0.7575112558637250,
0.9358720582947964, 0.7232968166410234,
0.9374537509894971, 0.6907058844038677,
0.9381313190610686, 0.6741459846039359,
0.9387306104700708, 0.6564935206746780,
0.9394477900034081, 0.6243435221799847,
0.9396117207300483, 0.5937778670872914,
0.9394874840803522, 0.5782311278110679,
0.9392029319995888, 0.5616407919734064,
0.9382994656122418, 0.5312492872196056,
0.9370386115839201, 0.5020459255177667,
0.9362833519118319, 0.4870445508964580,
0.9354248437960636, 0.4710178235946623,
0.9337808390207332, 0.4413163062115267,
0.9322411205299899, 0.4123647909341087,
0.9315098604497338, 0.3973513238714723,
0.9308026960717580, 0.3813288987081724,
0.9297265156529937, 0.3514256569169673,
0.9290167357505270, 0.3220889223657142,
0.9287894564202763, 0.3068273456265949,
0.9286526243323889, 0.2906977997636500,
0.9286673385094586, 0.2605530821860786,
0.9289830076511727, 0.2309519301994001,
0.9292459910168920, 0.2155462382693815,
0.9295773439757022, 0.1994763567533360,
0.9303124588007873, 0.1694150449585416,
0.9311107043188446, 0.1398385880056010,
0.9315281681667847, 0.1244126512243995,
0.9319421832357826, 0.1085462522309068,
0.9326343752052738, 0.0787522118851352,
0.9331505579487476, 0.0492575686814132,
0.9333332530673241, 0.0337885197571809,
0.9334491696870718, 0.0180990154347046,
0.9334652161671392, -0.0115710492663892,
0.9332120244039133, -0.0412345712766281,
0.9329789224787809, -0.0569149577019996,
0.9326862549995626, -0.0725884459925477,
0.9320001411192669, -0.1024599469522399,
0.9312129883608152, -0.1326118836367079,
0.9307899849024192, -0.1486561549398251,
0.9303909075065188, -0.1644271116072852,
0.9297250345489299, -0.1946330450139784,
0.9292548755930655, -0.2252834073476859,
0.9291130705998721, -0.2416455919397834,
0.9290578608374939, -0.2574314137739983,
0.9291877172614502, -0.2877313765233138,
0.9296392167416051, -0.3185617460026522,
0.9300046495490484, -0.3350585368889353,
0.9304236974567054, -0.3507182133721108,
0.9314003462995398, -0.3808622041888480,
0.9325674108739979, -0.4116817458717514,
0.9332359538989838, -0.4282482596647269,
0.9338721777211093, -0.4437838551320116,
0.9350851586203215, -0.4738546476649538,
0.9362337225344213, -0.5048569531934802,
0.9367818716931928, -0.5216417091996792,
0.9372326487630080, -0.5372496032556739,
0.9379121601866929, -0.5676787811706082,
0.9383028853033446, -0.5993536059244651,
0.9383666792864038, -0.6166296678180199,
0.9383326862780753, -0.6326245827297303,
0.9379977723892718, -0.6639938148093708,
0.9373003102346006, -0.6968598099745840,
0.9367823822021495, -0.7148547507662460,
0.9362360353753446, -0.7313972827878407,
0.9350023493305973, -0.7638640430069111,
0.9335661860444295, -0.7978381844900760,
0.9327590535408906, -0.8163822496807408,
0.9320309730841791, -0.8332693517073799,
0.9306892837333537, -0.8662090373239525,
0.9295137723796404, -0.9003185681334207,
0.9290144277952974, -0.9187543869973961,
0.9286719879350783, -0.9353695084393042,
0.9283541471977725, -0.9674143986787426,
0.9286015638674177, -1.0000552836152352,
0.9290161649414789, -1.0174556544426925,
0.9295657002954498, -1.0329173498323352,
0.9311592859344664, -1.0623386967683197,
0.9335550627939015, -1.0917945543880494,
0.9351798139694625, -1.1072910071348530,
0.9368357408387338, -1.1209485768266294,
0.9406045381254291, -1.1466200849133295,
0.9452258872133014, -1.1719342416516145,
0.9480246170309029, -1.1851047535906001,
0.9507113147538543, -1.1966060752758050,
0.9563824190867231, -1.2180306037466935,
0.9628239434873420, -1.2389021574964270,
0.9665377844546728, -1.2496649261134714,
0.9699944372440337, -1.2589822316957622,
0.9770172740574613, -1.2762294018180120,
0.9846679964513435, -1.2928793200648567,
0.9889593819037404, -1.3014031072913510,
0.9928882703072454, -1.3087613961958073,
1.0006986860160525, -1.3223148499191200,
1.0089890857474013, -1.3353141471172378,
1.0135608550341795, -1.3419277174399942,
1.017734898166250, -1.3476798198288307,
1.0259265171648460, -1.3582218587807169,
1.0344785237967877, -1.3682770111532871,
1.0391315381508794, -1.3733826318131117,
1.0433787710791651, -1.3778310591921066,
1.0516392836342736, -1.3859506991860049,
1.0601652417839935, -1.3936598050745477,
1.0647673129008701, -1.3975591358304054,
1.0689541062061056, -1.4009584723686965,
1.0770388845141041, -1.4071527087579905,
1.0853254989401135, -1.4129913618875038,
1.0897717327371195, -1.4159360146065307,
1.0938548483417758, -1.4185299071046018,
1.1017000669979322, -1.4232478570362166,
1.1096959701320044, -1.4276679292055783,
1.1139671945927190, -1.4298916439369296,
1.1178012811942011, -1.4318134909373714,
1.1251522907900930, -1.4352790552182000,
1.1325956711971952, -1.4385410603185260,
1.1365649580738486, -1.4401648799291045,
1.1401447838041381, -1.4415704319349951,
1.1469794782036487, -1.4441178659101124,
1.1538809287080851, -1.4465006205699420,
1.1575526023889127, -1.4476797701040933,
1.1621144510564045, -1.4490818202256270,
1.1708284087515675, -1.4515592750155131,
1.1796308214907651, -1.4537882878043753,
1.1843077873189682, -1.4548658080753312,
1.1898459450181607, -1.4560558930877134,
1.2004198795578918, -1.4580685889150615,
1.211082926408630, -1.4597745753162372,
1.2167401960050557, -1.4605552799731072,
1.2233051043294847, -1.4613604141879750,
1.2358156814036265, -1.4626050153518977,
1.2484028222918215, -1.4634893469613968,
1.2550657336293269, -1.4638259566905707,
1.2624729479875252, -1.4641038700577353,
1.2765541647349785, -1.4643425231829699,
1.2906613390425958, -1.4642622033233630,
1.2981089593082111, -1.4640991675321180,
1.3062073190521180, -1.4638425375975725,
1.3215474724125309, -1.4631414260509821,
1.3368532629209975, -1.4622097309769897,
1.3449073537334779, -1.4616425817558900,
1.3534282781392337, -1.4609985420036191,
1.3695171001099620, -1.4596842100446286,
1.3855090698520285, -1.4582982549968966,
1.3939020551445884, -1.4575566549115406,
1.4027539943367335, -1.4567743332182903,
1.4194332964315679, -1.4553238248365981,
1.4359778230160103, -1.4539501126206322,
1.4446518163861468, -1.4532643607447617,
1.4537533059446819, -1.4525734109752890,
1.4709016931988526, -1.4513508796057917,
1.4879239685427934, -1.4502249789567825,
1.4968580391995714, -1.4496574855959663,
1.5062091540425893, -1.4490701300508511,
1.5238601309001412, -1.4479423896685302,
1.5414278249475579, -1.4467239623241193,
1.5506669739348420, -1.4460145501653443,
1.5603975377269022, -1.4451975016677336,
1.5787968153546230, -1.4433971412934141,
1.5971395836825037, -1.4411873969177775,
1.6067931136409208, -1.4398283467286876,
1.6169572297887009, -1.4382348499638891,
1.6361697070959487, -1.4347209184440923,
1.6552976560446997, -1.4305199686094909,
1.6653481621169417, -1.4280136258145086,
1.6759519111468937, -1.4251356801186645,
1.6959424266183702, -1.4190470523882144,
1.7157666875515263, -1.4121090684934763,
1.7261477202171405, -1.4081209240148416,
1.7372240661056688, -1.4035913774429019,
1.7580203346892824, -1.3943231704893302,
1.7785283547356683, -1.3841799972824675,
1.7892209627434263, -1.3785051551708951,
1.8005496538590582, -1.3722021899835937,
1.8217218667331907, -1.3596248782760620,
1.8424756252520860, -1.3462730724341514,
1.8532484560706177, -1.3389565144908899,
1.8647028031309225, -1.3308823123570430,
1.8860092355211213, -1.3150477970475536,
1.9067738833526542, -1.2986304167264910,
1.9175048375203145, -1.2897521019554632,
1.9289418569888102, -1.2800028874398812,
1.9501243384702369, -1.2611647848532301,
1.9706547035372830, -1.2419342463512799,
1.9812233349523041, -1.2316594383373598,
1.9924138884063607, -1.2205056724666314,
2.0130641212249656, -1.1991833926369138,
2.0329850244721106, -1.1776727303689156,
2.0432083316695460, -1.1662857829329463,
2.0539813607878057, -1.1540244872434631,
2.0738001255976388, -1.1307576254634284,
2.0928526319722787, -1.1075137202936105,
2.1026050334168334, -1.0952824024106707,
2.1128742294545866, -1.0821495723275507,
2.1317177724823013, -1.0573603137786380,
2.1497770144218880, -1.0327495422209299,
2.1589991888329187, -1.0198488473489480,
2.1686284391343928, -1.0061260473083904,
2.1862583824816939, -0.9803068244952513,
2.203101101804160, -0.9547533752782646,
2.2116805468419551, -0.9413842418096301,
2.2205924562531894, -0.9272265890095427,
2.2368639707340634, -0.9006267599377006,
2.2523385989874898, -0.8743200663740174,
2.2601925397833136, -0.8605627759501708,
2.2682878910301314, -0.8460698543332468,
2.2830018181934459, -0.8188363241456473,
2.2969093559621832, -0.7919067205586864,
2.3039258698302842, -0.7778148687316317,
2.3111519092648289, -0.7629178378502254,
2.3241915427469628, -0.7349147731583999,
2.3363941100541648, -0.7072200285741677,
2.3425014090343019, -0.6927313653714713,
2.348732781579550, -0.6774548236732403,
2.3598698077403610, -0.6487485324299012,
2.3701441700230603, -0.6203692314237829,
2.375229651466980, -0.6055334438867901,
2.3803481755227445, -0.5899870744923478,
2.3893839849445069, -0.5608046231662923,
2.3975691611042631, -0.5319943882699155,
2.4015607628120916, -0.5169505330086902,
2.4055075270858017, -0.5013133848165174,
2.4123595517629259, -0.4719966363739619,
2.4184235771987082, -0.4431063936285912,
2.4213191475191156, -0.4280372751677591,
2.4241091808959108, -0.4125551399545123,
2.4288384740858286, -0.3835560594765408,
2.4328783621439301, -0.3550108864440105,
2.4347433409389247, -0.3401304474898429,
2.4364716976261023, -0.3250519940864202,
2.4392787480099174, -0.2968120317242641,
2.4415148367918684, -0.2690103419037187,
2.4424778462652252, -0.2545140312962006,
2.4433082481521393, -0.2399713789961771,
2.4445118007819233, -0.2127113248888007,
2.4452671071960390, -0.1858332818774149,
2.4455025097003751, -0.1717999139837286,
2.4456343295206078, -0.1577857456523333,
2.4456176189956342, -0.1314658496150812,
2.4453024541726869, -0.1054401420618141,
2.4450372243519678, -0.0918167211579495,
2.4447157429636781, -0.0782369989541759,
2.4439934144943316, -0.0526484915973951,
2.4432042479339322, -0.0272148323233928,
2.4427994658877048, -0.0138381561686194]

i = 0
nimr = []
nimz = []
for rz in nimbdry:
    if i == 0:
        i = 1
        nimr.append(rz)
    else:
        i = 0
        nimz.append(rz)

nimr = np.array(nimr)
nimz = np.array(nimz)

data = np.loadtxt(fullFile)
sizes=0.005
sizes2=0.05
sizes2=0.5

surfaces = []
n3m1 = [53,63,66,97,98,10,116,139,236,240,264,276,283,287]
n2m1 = [94,109,170,199,252]
#print(data.shape)
last_surface = -1
n_surface = 0
for ii in range(data.shape[0]):
  if data[ii,3]== last_surface:
    n_surface = n_surface+1
  else:
    if n_surface > 0:
      this_surface = np.zeros([n_surface,2])
      this_surface = data[i_start:ii,0:2]
      surfaces.append(this_surface)
    i_start = ii
    n_surface = 1
    last_surface = data[ii,3]
this_surface = data[i_start:,0:2]
surfaces.append(this_surface)

#print(len(surfaces))
lastl =0.0
nskip=1


fig=plt.figure(figsize=(4,6))
ax = fig.add_subplot(111)
for i_surface in range(0,len(surfaces),nskip):
  this_surface = surfaces[i_surface]
  ax.scatter(this_surface[:,0],this_surface[:,1],s=sizes,c='k')
for i_surface in n3m1:
  this_surface = surfaces[i_surface]
  ax.scatter(this_surface[:,0],this_surface[:,1],s=sizes2)
for i_surface in n2m1:
  this_surface = surfaces[i_surface]
  ax.scatter(this_surface[:,0],this_surface[:,1],s=sizes2)
plt.plot(DRWALL, DZWALL, c='k')
plt.plot(DRLIM, DZLIM, c='k')
plt.plot(nimr, nimz, c='r')
plt.title(r"Magnetic Surfaces", size=16)  
ax.set_xlabel(r"$R$", size=16)
ax.set_ylabel(r"$Z$",size=16,rotation=0)
plt.axis('equal')
ax.set_xlim([1,2.5])
plt.tight_layout()
plt.show()


fig=plt.figure(figsize=(8,6))
ax = fig.add_subplot(111)
#for i_surface in range(0,len(surfaces),nskip):
#  this_surface = surfaces[i_surface]
#  for ii in range(this_surface.shape[0]):
    #print(ii, this_surface[ii,0],this_surface[ii,1])
#    psi, theta = map.getpt(np.array([this_surface[ii,0],this_surface[ii,1]]))
#    ax.scatter(theta,psi,s=sizes,c='k')
for i_surface in range(0,len(surfaces),nskip):
  this_surface = surfaces[i_surface]
  new_surface = np.zeros_like(this_surface)
  for ii in range(this_surface.shape[0]):
    new_surface[ii,1], new_surface[ii,0] = map.getpt(np.array([this_surface[ii,0],this_surface[ii,1]]))
    #print(ii, this_surface[ii,0],this_surface[ii,1])
#    psi, theta = map.getpt(np.array([this_surface[ii,0],this_surface[ii,1]]))
  ax.scatter(new_surface[:,0], new_surface[:,1],s=sizes2)
for i_surface in n3m1:
  this_surface = surfaces[i_surface]
  new_surface = np.zeros_like(this_surface)
  for ii in range(this_surface.shape[0]):
    new_surface[ii,1], new_surface[ii,0] = map.getpt(np.array([this_surface[ii,0],this_surface[ii,1]]))
    #print(ii, this_surface[ii,0],this_surface[ii,1])
#    psi, theta = map.getpt(np.array([this_surface[ii,0],this_surface[ii,1]]))
  ax.scatter(new_surface[:,0], new_surface[:,1],s=sizes2,c='k')

#    ax.scatter(this_surface[:,0],this_surface[:,1],s=sizes2)
#for i_surface in n2m1:
#  this_surface = surfaces[i_surface]
#  ax.scatter(this_surface[:,0],this_surface[:,1],s=sizes2)
#plt.plot(RLIM, ZLIM, c='k')
plt.title(r"Magnetic Surfaces", size=16)  
ax.set_xlabel(r"$\Theta$", size=16)
ax.set_ylabel(r"$\Psi$",size=16,rotation=0)
#plt.axis('equal')
#ax.set_ylim([0,])
ax.set_xlim([0,2*np.pi])
ax.set_ylim([0,1])
plt.tight_layout()
plt.show()

fig=plt.figure(figsize=(8,6))
ax = fig.add_subplot(111)
#for i_surface in range(0,len(surfaces),nskip):
#  this_surface = surfaces[i_surface]
#  for ii in range(this_surface.shape[0]):
    #print(ii, this_surface[ii,0],this_surface[ii,1])
#    psi, theta = map.getpt(np.array([this_surface[ii,0],this_surface[ii,1]]))
#    ax.scatter(theta,psi,s=sizes,c='k')
for i_surface in range(0,len(surfaces),nskip):
  this_surface = surfaces[i_surface]
  new_surface = np.zeros_like(this_surface)
  for ii in range(this_surface.shape[0]):
    new_surface[ii,1], new_surface[ii,0] = map.getpt(np.array([this_surface[ii,0],this_surface[ii,1]]))
    #print(ii, this_surface[ii,0],this_surface[ii,1])
#    psi, theta = map.getpt(np.array([this_surface[ii,0],this_surface[ii,1]]))
  ax.scatter(new_surface[:,0], new_surface[:,1],s=sizes2)
for i_surface in n3m1:
  this_surface = surfaces[i_surface]
  new_surface = np.zeros_like(this_surface)
  for ii in range(this_surface.shape[0]):
    new_surface[ii,1], new_surface[ii,0] = map.getpt(np.array([this_surface[ii,0],this_surface[ii,1]]))
    #print(ii, this_surface[ii,0],this_surface[ii,1])
#    psi, theta = map.getpt(np.array([this_surface[ii,0],this_surface[ii,1]]))
  ax.scatter(new_surface[:,0], new_surface[:,1],s=sizes2,c='k')

#    ax.scatter(this_surface[:,0],this_surface[:,1],s=sizes2)
#for i_surface in n2m1:
#  this_surface = surfaces[i_surface]
#  ax.scatter(this_surface[:,0],this_surface[:,1],s=sizes2)
#plt.plot(RLIM, ZLIM, c='k')
plt.title(r"Magnetic Surfaces", size=16)  
ax.set_xlabel(r"$\Theta$", size=16)
ax.set_ylabel(r"$\Psi$",size=16,rotation=0)
#plt.axis('equal')
#ax.set_ylim([0,])
ax.set_xlim([0,2*np.pi])
ax.set_ylim([0.5,0.7])
plt.tight_layout()
plt.show()